﻿using System;
using Lidgren.Network;

namespace UDPLibBench.Lidgren_Old
{
    public class Server
    {
        public int ReliableReceived;
        public int ReliableSent;
        public int UnreliableReceived;
        public int UnreliableSent;

        NetServer _server;
        NetBuffer _writer;
        NetConnection _peer;

        public Server()
        {
            NetConfiguration _config = new NetConfiguration("ConnKey");
            _config.Port = 9050;

            _server = new NetServer(_config);
            _server.Start();
        }

        public void SendUnreliable(string pData)
        {
            if (_peer == null) return;

            _writer = new NetBuffer();
            _writer.Write(false);
            _writer.Write(pData);

            _peer.SendMessage(_writer, NetChannel.Unreliable);
            UnreliableSent++;
        }

        public void SendReliable(string pData)
        {
            if (_peer == null) return;

            _writer = new NetBuffer();
            _writer.Write(true);
            _writer.Write(pData);

            _peer.SendMessage(_writer, NetChannel.ReliableInOrder1);
            ReliableSent++;
        }

        public void PollEvents()
        {
            NetBuffer _readBuffer;
            NetMessageType _msgType;
            NetConnection _conn;

            while(_server.ReadMessage(_readBuffer = _server.CreateBuffer(), out _msgType, out _conn))
            {
                switch(_msgType)
                {
                    case NetMessageType.StatusChanged:
                        _peer = _conn;
                        break;

                    case NetMessageType.Data:
                        ProcessData(_readBuffer);
                        break;
                }
            }
        }

        void ProcessData(NetBuffer reader)
        {
            var _isReliable = reader.ReadBoolean();
            var _data = reader.ReadString();

            if(_isReliable)
            {
                ReliableReceived++;
            }
            else
            {
                UnreliableReceived++;
            }
        }
    }
}
