﻿using System;
using Lidgren.Network;

namespace UDPLibBench.Lidgren_Old
{
	public class Client
	{
		public int ReliableReceived;
		public int ReliableSent;
		public int UnreliableReceived;
		public int UnreliableSent;

        NetClient _client;
		NetBuffer _writer;

		public Client()
		{
			NetConfiguration _config = new NetConfiguration("ConnKey");

            _client = new NetClient(_config);
            _client.Start();
		}

        public void Connect()
        {
            _client.Connect("localhost", 9050);
        }

		public void SendUnreliable(string pData)
		{
            if (_client.Status != NetConnectionStatus.Connected) return;

			_writer = new NetBuffer();
			_writer.Write(false);
			_writer.Write(pData);

            _client.SendMessage(_writer, NetChannel.Unreliable);
			UnreliableSent++;
		}

		public void SendReliable(string pData)
		{
            if (_client.Status != NetConnectionStatus.Connected) return;

			_writer = new NetBuffer();
			_writer.Write(true);
			_writer.Write(pData);

            _client.SendMessage(_writer, NetChannel.ReliableInOrder1);
			ReliableSent++;
		}

		public void PollEvents()
		{
			NetBuffer _readBuffer;
			NetMessageType _msgType;

            while (_client.ReadMessage(_readBuffer = _client.CreateBuffer(), out _msgType))
			{
				switch (_msgType)
				{
					case NetMessageType.StatusChanged:
						break;

					case NetMessageType.Data:
						ProcessData(_readBuffer);
						break;
				}
			}
		}

		void ProcessData(NetBuffer reader)
		{
			var _isReliable = reader.ReadBoolean();
			var _data = reader.ReadString();

			if (_isReliable)
			{
				ReliableReceived++;
			}
			else
			{
				UnreliableReceived++;
			}
		}
	}
}
